pmarlen-webrf3/src/main/java/com/pmarlen/web/security/managedbean/SessionUserMB.java
package com.pmarlen.web.security.managedbean;

import java.util.*;
import java.text.*;
import java.io.*;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.pmarlen.model.beans.Usuario;
import com.pmarlen.model.beans.Perfil;
import com.pmarlen.model.controller.UsuarioJPAController;
import com.pmarlen.model.Constants;
import com.pmarlen.web.servlet.ContextAndSessionListener;
import com.pmarlen.web.servlet.SessionInfo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SessionUserMB {

	private final Logger logger = LoggerFactory.getLogger(SessionUserMB.class);
	private static SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss:SSS");
	private UsuarioJPAController usuarioJPAController;
	private Usuario usuarioAuthenticated;

	public void setUsuarioJPAController(UsuarioJPAController usuarioJPAController) {
		this.usuarioJPAController = usuarioJPAController;
	}

	public Usuario getUsuarioAuthenticated() {
		if (usuarioAuthenticated == null) {
			FacesContext fCtx = FacesContext.getCurrentInstance();
			ExternalContext externalContext = fCtx.getExternalContext();
			HttpSession session = (HttpSession) externalContext.getSession(false);
			String sessionId = session.getId();
			
			String remoteUser      = externalContext.getRemoteUser();
			String userPrincipal   = externalContext.getUserPrincipal().getName();
			
			logger.info("==>> getUsuarioAuthenticated : Session[" + sessionId + "] first enter: remoteUser=" + remoteUser+", userPrincipal=" + userPrincipal);
				
			if (remoteUser != null) {
				
				Date creationTime = new Date(session.getCreationTime());

				logger.debug("==>> UsuarioAuthenticated : Session[" + sessionId + "] created     :" + sdf.format(creationTime));
				logger.debug("==>> UsuarioAuthenticated : Session[" + sessionId + "] new         ?" + session.isNew());
				usuarioAuthenticated = this.usuarioJPAController.findById(remoteUser);
				if (usuarioAuthenticated != null && !session.isNew()) {
					logger.debug("\t==>> usuarioAuthenticated : Session[" + sessionId + "] True enter :" + usuarioAuthenticated);
					SessionInfo si = ContextAndSessionListener.sessionInfoHT.get(sessionId);
					if (si != null) {
						si.setUserName(remoteUser);
					} else {
						si = new SessionInfo(session, usuarioAuthenticated.getNombreCompleto());
						ContextAndSessionListener.sessionInfoHT.put(sessionId, si);
					}
				}
			}
		}
		return usuarioAuthenticated;
	}

	public String getSessionTimeOutMinus3SecsToDisplay() {
		HttpServletRequest r = null;

		r = (HttpServletRequest) FacesContext.getCurrentInstance().getExternalContext().getRequest();
		r.getSession().getMaxInactiveInterval();

		return String.valueOf(r.getSession().getMaxInactiveInterval() - 3);
	}

	public void updateLastVisitedPage(String page) {
		FacesContext fCtx = FacesContext.getCurrentInstance();
		ExternalContext externalContext = fCtx.getExternalContext();
		HttpSession session = (HttpSession) externalContext.getSession(false);
		HttpServletRequest request = (HttpServletRequest) (externalContext.getRequest());
		String sessionId = session.getId();
		String userAgent = request.getHeader("User-Agent");
		String remoteAdrrInfo = request.getRemoteAddr() + "(" + request.getRemoteHost() + ")";
		logger.debug("==>> updateLastVisitedPage : page"+page+" from : "+ remoteAdrrInfo +" using:"+userAgent);
		SessionInfo si = ContextAndSessionListener.sessionInfoHT.get(sessionId);
		if(si != null) {
			si.setLastVisitedPage(page);
			si.setRemoteAddr(remoteAdrrInfo);
			if(userAgent != null){
				si.setUserAgent(userAgent);
			}
		}
	}

	public boolean isRootUser() {
		if (usuarioAuthenticated != null) {
			Perfil perfilFinalUser = new Perfil();
			Collection<Perfil> perfilCollection = usuarioAuthenticated.getPerfilCollection();
			perfilFinalUser.setId(Constants.PERFIL_ROOT);
			return perfilCollection.contains(perfilFinalUser);
		} else {
			return false;
		}
	}

	public boolean isAdminUser() {
		if (usuarioAuthenticated != null) {
			Perfil perfilFinalUser = new Perfil();
			Collection<Perfil> perfilCollection = usuarioAuthenticated.getPerfilCollection();
			perfilFinalUser.setId(Constants.PERFIL_ADMIN);
			return isRootUser() || perfilCollection.contains(perfilFinalUser);
		} else {
			return false;
		}
	}

	public boolean isSalesUser() {
		if (usuarioAuthenticated != null) {

			Perfil perfilFinalUser = new Perfil();
			Collection<Perfil> perfilCollection = usuarioAuthenticated.getPerfilCollection();
			perfilFinalUser.setId(Constants.PERFIL_SALES);
			return isRootUser() || perfilCollection.contains(perfilFinalUser);
		} else {
			return false;
		}
	}

	public boolean isStockUser() {
		if (usuarioAuthenticated != null) {
			Perfil perfilFinalUser = new Perfil();
			Collection<Perfil> perfilCollection = usuarioAuthenticated.getPerfilCollection();
			perfilFinalUser.setId(Constants.PERFIL_STOCK);
			return isRootUser() || perfilCollection.contains(perfilFinalUser);
		} else {
			return false;
		}
	}
}

pmarlen-webrf3/src/main/webapp/templates/include/dynamic-css.xhtml
<style  xmlns="http://www.w3.org/1999/xhtml"
		xmlns:ui="http://java.sun.com/jsf/facelets"
		xmlns:h="http://java.sun.com/jsf/html"
		xmlns:f="http://java.sun.com/jsf/core"
		xmlns:a4j="http://richfaces.org/a4j"
		type="text/css" >

.mainBodyLayout {
	border-collapse:collapse;
	padding:0px;	
	width:100%;
	vertical-align: top;
	overflow:scroll;
}

.pic {
	margin-bottom: -4px;
	margin-right: 2px;
	padding: 2px;
}

.search .rich-menu-item-hover{
	background-color: transparent;
	border-color: transparent;
}

.rich-menu-item{
	text-align: left;
}

.rich-menu-group{
	text-align: left;
}

.rich-menu-item-hover{
	text-align: left;	
}

.rich-menu-group-over{
	text-align: left;
}
.body-main-panel {
	background-color: transparent;
	border-color: transparent;
	height: 100%;
	vertical-align: top;
	min-height:400px;
}

   
body_image{
	background-image: url('${facesContext.externalContext.requestContextPath}/images/bg_1.jpg');
	background-repeat: no-repeat;
	background-position:right top;
	background-color:#ffffff;
	font-family: Arial,Helvetica,sans-serif;
}

body{
	background-color:#829498;
	font-family: Arial,Helvetica,sans-serif;
}

.rich-panel-header {				
	text-align: left;
	height: 22px;
	padding: 2px;
}

.table_lines
{
	border-collapse:collapse;
	border: 1px solid black;
	text-align: center;
	alignment-adjust: central;
}
.table_lines tr td
{
	border: 1px solid black;
}

.label_bold_right {
	display:block; 
	font-weight:bold; 
	text-align:right;
	font-family: Arial,Helvetica,sans-serif;
	font-size:12px;
}
.common_component_bold {
	font-weight:bold; 	
	font-family: Arial,Helvetica,sans-serif;
	font-size:12px;
}

.common_font_component {
	font-family: Arial,Helvetica,sans-serif;
	font-size:12px;
}

.littleLabel_bold_right {
	display:block;
	font-weight:bold;
	text-align:right;
	font-family: Arial,Helvetica,sans-serif;
	font-size:10px;
}

.inputCant{
	text-align:right;	
}

.common_font_littleComponent {
	font-family: Arial,Helvetica,sans-serif;
	font-size:10px;
}
.columnWidth2{
	width: 2%;
}

.columnWidth5{
	width: 5%;
}

.columnWidth10{
	width: 10%;
}

.columnWidth15{
	width: 15%;
}

.columnWidth20{
	width: 20%;
}

.columnWidth25{
	width: 25%;
}

.columnWidth30{
	width: 30%;
}

.columnWidth35{
	width: 35%;
}

.columnWidth40{
	width: 40%;
}

.columnWidth45{
	width: 45%;
}

.columnWidth50{
	width: 50%;
}

.columnWidth60{
	width: 60%;
}

.columnWidth65{
	width: 65%;
}

.columnWidth70{
	width: 70%;
}

.columnWidth75{
	width: 75%;
}

.columnWidth80{
	width: 80%;
}

.columnWidth85{
	width: 85%;
}

.columnWidth90{
	width: 90%;
}

.columnWidth95{
	width: 95%;
}

.centerAlign {
	text-align: center;
}

.leftAlign {
	text-align: left;
}

.rightAlign {
	text-align: right;
}
.topAlign {
	vertical-align: top;
}
.rich-messages-marker img {
	padding-right:7px;			
}
.rich-message-marker img {
	padding-right:7px;		
}

.littleInfoMessage_bold {						
	display: inline;
	font-weight: normal;
	text-align: left;
	font-size:12px;
	color: green;
	display: block;
}
.littleWarnMessage_bold {
	display: inline;
	font-weight: normal;
	text-align: left;
	font-size:12px;
	color: red;		
	display: block;
}
.littleErrorMessage_bold {
	display: inline;
	font-weight: bold;
	text-align: left;
	font-size:12px;
	color: red;
	display: block;
}
.footer-text{
	color: darkslategrey;
	font-family: Arial,Helvetica,sans-serif;
	font-size: 8;				
}

.input-required-true{
	text-decoration:underline
}

.input-required-false{
	text-decoration:none
}

.no_padding{
	padding: 0px;	
}

.valign_td {
	vertical-align: middle;	
}

</style>

pmarlen-webrf3/src/main/webapp/templates/include/footer.xhtml
<h:panelGroup	xmlns="http://www.w3.org/1999/xhtml"
			  xmlns:ui="http://java.sun.com/jsf/facelets"
			  xmlns:h="http://java.sun.com/jsf/html"
			  xmlns:f="http://java.sun.com/jsf/core"
			  xmlns:a4j="http://richfaces.org/a4j"
			  style="vertical-align: top;text-align: center; width: 100%;" >

<!--
	#{UIMessages.APP_BUILD_LABEL} : #{versionInfo.maven_build_timestamp} |	#{UIMessages.APP_VERSION_LABEL} : #{versionInfo.version}
-->
	
</h:panelGroup>


pmarlen-webrf3/src/main/webapp/templates/include/header.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:c="http://java.sun.com/jsp/jstl/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:rich="http://richfaces.org/rich" 
		id="headerForm">

	<h:panelGrid columns="3" width="100%" 
				 columnClasses="columnWidth5 leftAlign,columnWidth65 leftAlign,columnWidth30 rightAlign">

		<h:outputLink value="${facesContext.externalContext.requestContextPath}/">
			<h:graphicImage value="/images/Logo_T1_Q25.jpg"/>
		</h:outputLink>

		<h:panelGrid columns="1">
			<h:outputText value="#{UIMessages.MAIN_LEGEND}" style="font-family: verdana; font-size: large"/>
			<h:outputText value="#{UIMessages.MAIN_SUBLEGEND}" style="font-family: verdana; font-size: medium"/>
			<h:outputText value="#{UIMessages.MAIN_SYSTEM_NAME}" style="font-family: verdana; font-size: small"/>								
		</h:panelGrid>

		<h:panelGrid width="100%" 
					 columnClasses="columnWidth35 rightAlign,columnWidth65 leftAlign"
					 columns="1"
					 border="0">

			<h:panelGroup>			
				<h:outputText value="BIENVENIDO" class="common_component_bold"/>				        
				<h:outputText rendered="#{not empty sessionUserMB.usuarioAuthenticated}" 
							  value="  #{sessionUserMB.usuarioAuthenticated.nombreCompleto}" 
							  class="common_component_bold"/>				        
			</h:panelGroup>
			
			<!--
			<a4j:repeat var="perfil" value="#{sessionUserMB.usuarioAuthenticated.perfilCollection}">
				[<h:graphicImage id="graphicImageUser" value="/images/Perfil_#{perfil.id}_icon.gif" title="#{perfil.descripcion}" />]
			</a4j:repeat>
			-->
			
			<h:outputLink value="${facesContext.externalContext.requestContextPath}/logout">
				<h:graphicImage value="/images/door_in.gif" title="#{UIMessages.COMMON_EXIT}"/>
			</h:outputLink>
			
			<h:commandLink rendered="#{navigationMB.renderedForMobile}" 
						   action="#{navigationMB.swapMenuStyle}"
						   style="font-family: Arial; font-size : 8px;font-weight : bold;">
				<h:graphicImage value="/images/menubar_icon.gif" 
								title="Cambiar a barra de Menú" alt="Barra de Menú"/>
			</h:commandLink>

			<h:commandLink rendered="#{not navigationMB.renderedForMobile}" 
						   action="#{navigationMB.swapMenuStyle}"
						   style="font-family: Arial; font-size : 8px;font-weight : bold;">
				<h:graphicImage value="/images/panelmenu_icon.gif" 
								title="Cambiar a Menú lateral fijo" alt="Menú lateral fijo"/>
			</h:commandLink>
<!--
			<h:panelGroup>
				<a4j:repeat var="locale" value="#{navigationMB.supportedLocales}">

					<h:graphicImage rendered="#{navigationMB.locale eq locale}"
									value="/images/flag-#{locale}-selected.gif" 
									title="#{locale.displayLanguage}" alt=" [ #{locale.displayLanguage} ] "/>

					<h:commandLink	rendered="#{navigationMB.locale ne locale}"
								   action="#{navigationMB.changeLocale}">
						<h:graphicImage value="/images/flag-#{locale}.gif" 
										title="#{locale.displayLanguage}" alt="#{locale.displayLanguage}"/>
						<f:param name="localeToChange" value="#{locale}"/>							
					</h:commandLink>

					<h:outputText value=" "/>

				</a4j:repeat>	
			</h:panelGroup>
-->
		</h:panelGrid>

	</h:panelGrid>

</h:form>

pmarlen-webrf3/src/main/webapp/templates/include/menuBar.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:c="http://java.sun.com/jsp/jstl/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:rich="http://richfaces.org/rich"

		id="menuBarForm"
		rendered="#{not navigationMB.renderedForMobile}">

	<rich:toolBar>

		<rich:dropDownMenu >
			<f:facet name="label"> 
				<h:panelGroup>
					<h:graphicImage value="/images/almacen_rack_16x16.gif" styleClass="pic"/>
					<h:outputText value="#{UIMessages.MENU_OPERATION}"/>
				</h:panelGroup>
			</f:facet>
			
			<rich:menuGroup value="VENTAS">
				<rich:menuItem value="#{UIMessages.MENU_SALES_ORDER}" action="#{navigationMB.pedidoNuevo}"/>			
				
				<rich:menuItem value="PEDIDOS EN PROCESO" action="#{navigationMB.pedidosVentasView}"/>
				
			</rich:menuGroup>

			<rich:menuGroup value="COMPRAS">
				<rich:menuItem value="ENTRADA DE COMPRA" action="#{navigationMB.compra}"/>				
				<!--				
				<rich:menuItem value="ENTRADA DE COMPRA" action="#{navigationMB.home}"/>			
				-->
			</rich:menuGroup>
			
		</rich:dropDownMenu>

		<rich:dropDownMenu rendered="#{sessionUserMB.stockUser or sessionUserMB.adminUser}">
			<f:facet name="label"> 
				<h:panelGroup>
					<h:graphicImage value="/images/building.gif" styleClass="pic"/>
					<h:outputText value="#{UIMessages.MENU_ADMINISTRATION}" />
				</h:panelGroup>
			</f:facet>
			<rich:menuGroup value="#{UIMessages.MENU_CATALOGS}">

				<rich:menuItem value="#{UIEntityLabels.MENU_CRUD_LINEA}" action="#{navigationMB.catalogoLinea}"/>

				<rich:menuItem value="#{UIEntityLabels.MENU_CRUD_INDUSTRIA}" action="#{navigationMB.catalogoIndustria}" />

				<rich:menuItem value="#{UIEntityLabels.MENU_CRUD_MARCA}" action="#{navigationMB.catalogoMarca}" />

				<rich:menuItem value="#{UIEntityLabels.MENU_CRUD_CLIENTE}" action="#{navigationMB.catalogoCliente}" />

				<rich:menuItem value="#{UIEntityLabels.MENU_CRUD_PROVEEDOR}" action="#{navigationMB.catalogoProveedor}" />

				<rich:menuItem value="#{UIEntityLabels.MENU_CRUD_SUCURSAL}" action="#{navigationMB.catalogoSucursal}" rendered="#{sessionUserMB.adminUser}" />
				<!--
				<rich:menuItem value="Método de Pago" action="#{navigationMB.home}" />

				<rich:menuItem value="Forma de Pago" action="#{navigationMB.home}" />
				-->
				<rich:menuItem value="#{UIEntityLabels.MENU_CRUD_USUARIO}" action="#{navigationMB.catalogoUsuario}" />

				<rich:menuItem value="#{UIEntityLabels.MENU_CRUD_PRODUCTO}" action="#{navigationMB.catalogoProducto}" />

			</rich:menuGroup>

			<rich:menuGroup value="INVENTARIOS">
				
				<rich:menuItem value="INVENTARIOS ACTUALES" action="#{navigationMB.inventariosView}" />
				<!--
				<rich:menuItem value="TRASPASOS A SURSAL" action="#{navigationMB.home}"/>
				-->
			</rich:menuGroup>

		</rich:dropDownMenu>

		<rich:dropDownMenu  rendered="#{sessionUserMB.adminUser}">

			<f:facet name="label"> 
				<h:panelGroup>
					<h:graphicImage value="/images/building.gif" styleClass="pic"/>
					<h:outputText value="#{UIMessages.MENU_CONTROL}" />
				</h:panelGroup>
			</f:facet>

			<rich:menuItem value="#{UIMessages.MENU_SESSION_INFO}" action="#{navigationMB.activeSessions}" />

			<rich:menuItem value="CONFIGURACIONES" action="#{navigationMB.home}" />

		</rich:dropDownMenu>

		<rich:dropDownMenu rendered="#{sessionUserMB.stockUser or sessionUserMB.adminUser}">
			<f:facet name="label"> 
				<h:panelGroup>
					<h:graphicImage value="/images/icon_message_info_sm.gif" styleClass="pic"/>
					<h:outputText value="#{UIMessages.MENU_HELP}" />
				</h:panelGroup>
			</f:facet>
			
			<rich:menuItem value="SICOFI" action="#{navigationMB.home}" />

			<rich:menuItem value="ACERCA DE ESTE SISTEMA" action="#{navigationMB.home}" />

			<rich:menuItem value="CICLO DE VIDA DE UN PEDIDO" action="#{navigationMB.home}" />

		</rich:dropDownMenu>

	</rich:toolBar>

</h:form>

pmarlen-webrf3/src/main/webapp/templates/include/panelMenu.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:c="http://java.sun.com/jsp/jstl/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:rich="http://richfaces.org/rich"

		id="panelMenuForm">

	<rich:panelMenu binding="#{navigationMB.htmlPanelMenu}"/>

</h:form>